/*
    Robot server - 2005 Jason Hunt
    
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

    Contact: nulluser@gmail.com
    
    File: Cameratest.c
*/


#include <unistd.h>
#include <stdio.h>
#include <fcntl.h>
#include <linux/fb.h>
#include <sys/mman.h>
#include <sys/ioctl.h>

#include <stdio.h>
#include <stdlib.h>
#include <signal.h>

#include "camera_drv.h"
#include "decompress.h"


unsigned char done = 0;


int fbfd = 0;
struct fb_var_screeninfo vinfo;
struct fb_fix_screeninfo finfo;
long int screensize = 0;
unsigned short *fbp = 0;
int x = 0, y = 0;
long int location = 0;



/* Hangle signals */
void sighandler(int sig)
{
    done = 1;
}
/* End of sighandler */




int vga_start (void)
{
    fbfd = open("/dev/fb0", O_RDWR);

    if (!fbfd) 
    {
        printf("Error: cannot open framebuffer device.\n");
        return 1;
    }
    
    printf("The framebuffer device was opened successfully.\n");


    if (ioctl(fbfd, FBIOGET_FSCREENINFO, &finfo)) 
    {
        printf("Error reading fixed information.\n");
        return 1;
    }

    if (ioctl(fbfd, FBIOGET_VSCREENINFO, &vinfo)) 
    {
        printf("Error reading variable information.\n");
        return 1;
    }

    screensize = vinfo.xres * vinfo.yres * vinfo.bits_per_pixel / 8;


    fbp = (char *)mmap(0, screensize, PROT_READ | PROT_WRITE, MAP_SHARED, fbfd, 0);


    if ((int)fbp == -1) 
    {
        printf("Error: failed to map framebuffer device to memory.\n");
        return 1;
    }

    printf("The framebuffer device was mapped to memory successfully.\n");

    printf("vinfo.xoffset: %d\n", vinfo.xoffset);
    printf("vinfo.yoffset: %d\n", vinfo.yoffset);
    printf("vinfo.bits_per_pixel: %d\n", vinfo.bits_per_pixel);
    printf("finfo.line_length: %d\n", finfo.line_length);
    
    printf("vinfo.xres: %d\n", vinfo.xres);
    printf("vinfo.yres: %d\n", vinfo.yres);
     

 
    return 0;

}


int vga_stop (void)
{
    munmap(fbp, screensize);
    close(fbfd);

    return 0;
}


int main( void )
{

    unsigned char *buff;

    unsigned int image_x = 0;
    unsigned int image_y = 0;
    unsigned int max_image = 0;

    unsigned int screen_x = 240;
    unsigned int screen_y = 320;
   
   
    signal(SIGABRT, &sighandler);
	signal(SIGTERM, &sighandler);
	signal(SIGINT, &sighandler);
	
	
    printf("Open\n");


    cameradrv_start ("/dev/video0", &image_x, &image_y, &max_image);
          
      
    printf("Image_x: %d\n", image_x);
    printf("Image_y: %d\n", image_y);
    printf("Max image: %d\n", max_image);
        

    if (vga_start())
    {
        return 1;
    }

   unsigned short  *raw_image = (unsigned short  *)  malloc(image_x * image_y * sizeof(unsigned short ));
  
   
    buff = (unsigned char *) malloc(max_image * 8);
   
    unsigned int len;
      

    while (!done)
    {
        cameradrv_frame (buff, max_image, &len);
    
        unsigned char *p = buff;

//        printf("Len: %d\n", len);
/*        FILE *f = fopen("image.jpg", "wb");
        fwrite(buff, 1, len, f);
        fclose(f);*/
	

        decompress_image((char *) buff, len, raw_image, image_x, image_y);
                      
        int x, y;
	
	
    	unsigned int i = 0;
	
	
        for ( y = 0; y < screen_y ; y++)
            for (  x = 0; x < screen_x  ; x++)
            {
                unsigned int addr_x = x * image_x / screen_x;
                    unsigned int addr_y = y * image_y / screen_y;

                  //color_type c = raw_image [addr_x + addr_y * image_x];
  
                 // unsigned short val = ; ;//((unsigned short)(c.r >> 3) << 11) | ((unsigned short)(c.g>>2) << 5) | (c.b>>3); 
  
 
                   *(fbp + i++) =raw_image [addr_x + addr_y * image_x] ;
                 
                //i += 2;                                                                                  
               // i += 1;
                                                                                 
                //      *(fbp + location) =   (c.b << 16) + (c.g << 8) + c.b;     
                // unsigned char c = (*(base) + *(base+1)+ *(base+2) ) / 48 + 17;
             }
   
    }
    

    cameradrv_stop ();
    
    free(buff);
    
    free(raw_image);
    
    

    vga_stop();

       
    printf("Program exit  \n");

   return(0);
}


